package com.insys.example;

import java.util.ArrayList;

public class PrzeszukiwanieTablicy {

	protected static final String _exist = "Cig cyfr|liczb zawiera si w zbiorze gwnym od indeksu [%d,%d] do indeksu [%d,%d]";

	public PrzeszukiwanieTablicy() {
	}

	public static void main(String[] args) {
		/**
		 * Gdy tablica collection powtarzajce nie-unikalne elementy bdzie miaa
		 * wtedy w linii 59, prawodpodobnie podniesiony zostanie
		 * wyjtek java.lang.ArrayIndexOutOfBoundsException
		 * 
		 * 
		 * TODO: Sprawdzanie, czy numery wierszy:
		 *  :: nastpuj po sobie -- wtedy mamy szukan macierz
		 *  :: wystpuj w odwrotnej -- kolejnoci mamy macierz odwrcon
		 */
		int[][] collection = { 
				 { 1,  2,  3,  4,  5,  6,  7,  8 }
				,{ 9,  10, 11, 12, 13, 14, 15, 16 } 
				,{ 17, 18, 19, 20, 21, 22, 23, 24 }
				};
		int[][] subset = { 
				 {5,6,7} 
				,{20,21,22}
				};

		ArrayList<int[]> arr = new ArrayList<int[]>();

		for (int n = 0; n < subset.length; n++) {
			for (int m = 0; m < subset[n].length; m++) {
				int z = subset[n][m];
				for (int k = 0; k < collection.length; ++k) {
					for (int l = 0; l < collection[k].length; ++l) {
						int pz = collection[k][l];
						if (pz == z) {
							/**
							 * Najwaniejsze miejsce w tym kodzie
							 * Przechowujemy wskanik[numer-wiersza, numer-kolumny, warto-krotki]
							 */
							arr.add(new int[] { k, l, z });
						}
					}
				}
			}

			arr.trimToSize();
			boolean compact = false; 
			if (!arr.isEmpty()) {
				int prevCol = arr.get(0)[1]-1;
				for (int i = 0; i < arr.size(); i++) {
					int[] temp = arr.get(i);
					/**
					 * Sprawdzamy czy wartoci s takie same po lewej i prawej stronie
					 * Sprawdzamy czy numery kolumn nastpuj po sobie
					 */
					compact = (temp[2] == subset[n][i]) && (temp[1] == prevCol+1);
					prevCol = temp[1];
					if (!compact)
						break;
				}
	
				int startRow = arr.get(0)[0];  int endRow = arr.get(arr.size()-1)[0];  
				int startCol = arr.get(0)[1];  int endCol = arr.get(arr.size()-1)[1];
				if (compact)
					System.out.println(String.format(_exist, startRow, startCol, endRow, endCol));
			}
			arr.clear();
		}

	}

}
